// THIS RS232 PROGRAM DOES NOT SUPPORT INTERRUPTS, BUT IT DOES MAINTAIN
// EXISTING INTERRUPTS IF THEY PREVIOUSLY EXIST

#include <dos.h>
#include <conio.h>
#include "defines.h"
#include "dialogs.h"
#include "resource.h"
#include "codes.h"
#include <sys/types.h>
//#include <winsock.h>
#include <windows.h>
//extern "C"
//{
void send_baudot(int ch1, int MODE);
void RX();
void TX();
//}
enum mode {
     ascii,
     ita2,
     telex,
     military
};

extern int COMPORT;
extern unsigned int id_sent;
extern HWND MyHWnd;
extern int TxLine;
//extern int EnableGiveUp;

// Makes Visual C++ compatible with Borland C++
unsigned short outportb(unsigned short port,int value) { return (_outp(port,value)); }
unsigned short inportb(unsigned short port)          { return (_inp(port));        }

void GiveUp() {  // Hand resources back to the computer
MSG msg;
while (PeekMessage(&msg, (HWND) NULL, 0, 0,PM_REMOVE )) {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
}


/* Open the COM port     */
void OpenCom(int ComBase,
      float baud,
      int parity,
      int databits,
      int stopbits)
{
  int rate;
  int LCRreg;
  int LCRreg_old;

  COMPORT = ComBase; // Global comport ID
  
 
  // check to see power-up test mode is set, pre-initialization
		if ((inportb((unsigned short)(MCR+ComBase)) & 0x10) == 0x10)
  {
  outportb((unsigned short)(IER+ComBase), 0x00);
  outportb((unsigned short)(MCR+ComBase), 0x00);
  }

  LCRreg_old = inportb((unsigned short)(LCR+ComBase));
  LCRreg = 0x80;
  LCRreg = LCRreg | parity;
  LCRreg = LCRreg | databits;
		LCRreg = LCRreg | stopbits;
  outportb((unsigned short)(LCR+ComBase), LCRreg);
  rate = (int) (115200.0 / baud);

  /* Load the two bytes of the register */
  outportb((unsigned short)(DLM+ComBase), (char)((rate>>8)& 0xFF));      /* Hi byte */
  outportb((unsigned short)(DLL+ComBase), (char)(rate     & 0xFF));      /* Low byte */

  outportb((unsigned short)(LCR+ComBase), LCRreg_old &  0x3F);  // restore old settings
}


/* Transmits a character to the appropriate communications port   */
int xmitchar(int ch)
{
  int  LSRreg;
  char temp[40];
  do {
      LSRreg = inportb((unsigned short)(LSR+COMPORT)) & 0x20;
//      if (EnableGiveUp)
//													GiveUp();    // Seems I must block here  sometimes.
     }  while (LSRreg == 0);
		outportb((unsigned short)(RBR+COMPORT),ch);
//  PostMessage(HWND_BROADCAST, 502,ch, 0L);
wsprintf((LPSTR)temp, "%d", ++id_sent);
SetDlgItemText(MyHWnd, ID_SENT, (LPSTR)temp);
  return ch;
}


void send_baudot(int ch1, int MODE)
{
int indx = 0;
char c;
int cstate;    // current state, LTRS, FIGS, BOTH (yes, three states)

  indx = (int) ch1;
  if (indx > 96) indx -= 32;      /* lower case becomes upper case  */
  if (indx >95) indx = 0;          // maximum array size, blank it out
      cstate= table3[indx].state; /* get BAUDOT case                */
      if      (MODE == ita2)
          c= table3[indx].ita2;     // ita2 protocol
      else if (MODE == telex)
          c= table3[indx].telex;    // telex protocol
      else
          c= table3[indx].military; // default military
      if (c != UU)                /* untranslatable!    */
      {
   switch (c) {
    case BCR:  break;               // eat the line feed, BLF does it
    case BLF:  xmitchar(BCR);       // baudot return (unix/dos)
         xmitchar(BCR);       // Per George Hutchinson Request
         xmitchar(BLF);       // followed by line feed
         xmitchar(LTRS);      // Always force LTRS per George
                       state = LTRS;
                       break;
            case FIGS: xmitchar(FIGS);      // simple shift to FIGS
                       state= FIGS;
                       break;
            case LTRS:                       // letters
            case BSP:  xmitchar(c);          // send the letters/space char
                       if (state == FIGS)    // test the global state
                           xmitchar(LTRS);   // unshift on space
                       state = LTRS;         // set global state
                       break;
            default:   if (state == cstate) // send cuz in proper state
                           xmitchar(c);
                       else
                       {
                         xmitchar(cstate);   // do the shift
                         xmitchar(c);        // send the character
                         state = cstate;     // set the new state
                       }
                        break;
         } // case
      }    // if !UU
}

#define MCR 0x04   /* Modem Control Register              */
void TX(void)
{
int MCRSave;
   MCRSave = inportb((unsigned short)(MCR+COMPORT));      // Save Interrupt Enable
			outportb((unsigned short)(MCR+COMPORT),MCRSave | TxLine);// Transmitter ON
}
void RX(void)
{
int MCRSave;
  MCRSave = inportb((unsigned short)(MCR+COMPORT));      // Save Interrupt enable
		outportb((unsigned short)(MCR+COMPORT),MCRSave & (~TxLine&0xFF));// Transmitter Off
}

// both character set is NULL LF CR FIGS LTRS SPACE

/* finis */
