/* modemst6.h   */
#define COM1 0
#define COM2 1
#define COM3 2
#define COM4 3
#define COM5 4
#define COM6 5
#define COM7 6
#define COM8 7



/* Define values for AMTOR and BAUDOT states */
#define BOTH 0     /* case machine state */
#define NEITHER 99 /* initial case machine state */
#define UU 127     /* untranslatable character */

/* ASCII characters */
#define UU 127 /* untranslatable character */
#define NUL 0
/*
#define LF 10
#define CR 13  */
#define BEL 7


/* BAUDOT characters */
#define FIGS 27   /* Baudot FIGS character and case machine state */
#define LTRS 31   /* Baudot LTRS character and case machine state */
#define BCR 8     /* Baudot Carriage Return */
#define BSP 4     /* Baudot Space */
#define BLF 2     /* Baudot LineFeed */


/* Table of Baudot and AMTOR characters in ASCII order.*/
struct
{
   unsigned int state;
   char         ita2;  /* ita2 morray*/
   char         telex;    /* telex code */
   char         military; /* military code*/
} table3[] = {
   { BOTH, 0 ,  0,  0},  /*0  NULL */
   { BOTH, UU, UU, UU},  /*1  soh  */
   { BOTH, UU, UU, UU},  /*2  stx  */
   { BOTH, UU, UU, UU},  /*3  etx  */
   { BOTH, UU, UU, UU},  /*4  eot  */
   { BOTH, UU, UU, UU},  /*5  enq  */
   { BOTH, UU, UU, UU},  /*6  ack  */
   { FIGS,BSP, 11, 20},  /*7  bell INVALID FOR ITA2*/
   { BOTH, UU, UU, UU},  /*8  bs   */
   { BOTH, UU, UU, UU},  /*9  ht   */
   { BOTH, 2 ,  2,  2},  /*10 LF   */
   { BOTH, UU, UU, UU},  /*11 vt   */
   { BOTH, UU, UU, UU},  /*12 ff   */
   { BOTH, 8 ,  8,  8},  /*13 CR   */
   { BOTH, UU, UU, UU},  /*14 so */
   { BOTH, UU, UU, UU},  /*15 si */
   { BOTH, UU, UU, UU},  /*16 dle */
   { BOTH, UU, UU, UU},  /*17 dc1 */
   { BOTH, UU, UU, UU},  /*18 dc2 */
   { BOTH, UU, UU, UU},  /*19 dc3 */
   { BOTH, UU, UU, UU},  /*20 dc4 */
   { BOTH, UU, UU, UU},  /*21 nak */
   { BOTH, UU, UU, UU},  /*22 syn */
   { BOTH, UU, UU, UU},  /*23 etb */
   { BOTH, UU, UU, UU},  /*24 can */
   { BOTH, UU, UU, UU},  /*25 em */
   { BOTH, UU, UU, UU},  /*26 sub */
   { BOTH, 27, 27, 27},  /*27 FIGS */
   { BOTH, UU, UU, UU},  /*28 fs */
   { BOTH, UU, UU, UU},  /*29 gs */
   { BOTH, UU, UU, UU},  /*30 rs */
   { BOTH, 31, 31, 31},  /*31 LTRS */
   { BOTH,  4,  4,  4},  /*32 SPACE */
   { FIGS,BSP,BSP, 13},  /*33  (exclamation) (INVALID FOR ITA2 AND TELEX*/
   { FIGS, 17, 17, 17},  /*34 " */
   { FIGS, 20, 20, 20},  /*35 # */
   { FIGS,  9,  9,  9},  /*36 $ (dollar)    */
   { FIGS, 13,BSP,BSP},  /*37 % (percent)  INVALID TELEX MILITARY */
   { FIGS, 26, 26, 26},  /*38 & (ampersand) */
   { FIGS, 11,BSP, 11},  /*39 ' (sgl quote) */
   { FIGS, 15, 15, 15},  /*40 ( */
   { FIGS, 18, 18, 18},  /*41 ) */
   { FIGS,  3,  3,  3},  /*42 * (asterisk) SUBSTITUTED(-)*/
   { FIGS, 17,BSP,BSP},  /*43 + PLUS    */
   { FIGS, 12, 12, 12},  /*44 , COMMA*/
   { FIGS,  3,  3,  3},  /*45 - DASH*/
   { FIGS, 28, 28, 28},  /*46 . PERIOD*/
   { FIGS, 29, 29, 29},  /*47 / FORWARDSLASH*/
   { FIGS, 22, 22, 22},  /*48 0 */
   { FIGS, 23, 23, 23},  /*49 1 */
   { FIGS, 19, 19, 19},  /*50 2 */
   { FIGS,  1,  1,  1},  /*51 3 */
   { FIGS, 10, 10, 10},  /*52 4 */
   { FIGS, 16, 16, 16},  /*53 5 */
   { FIGS, 21, 21, 21},  /*54 6 */
   { FIGS, 7 ,  7,  7},  /*55 7 */
   { FIGS, 6 ,  6,  6},  /*56 8 */
   { FIGS, 24, 24, 24},  /*57 9 */
   { FIGS, 14, 14, 14},  /*58 : COLON*/
   { FIGS,BSP, 30, 30},  /*59 ; SEMICOLON invalid ita2*/
   { BOTH, UU, UU, UU},  /*60 (.LT.)  */
   { FIGS, 30,BSP,BSP},  /*61 (equal) */
   { BOTH, UU, UU, UU},  /*62 (.GT.)  */
   { FIGS, 25, 25, 25},  /*63 ?       */
   { FIGS, 11,BSP,BSP},  /*64 @ (at)  */
   { LTRS, 3 ,  3,  3},  /*65 A */
   { LTRS, 25, 25, 25},  /*66 B */
   { LTRS, 14, 14, 14},  /*67 C */
   { LTRS, 9 ,  9,  9},  /*68 D */
   { LTRS, 1 ,  1,  1},  /*69 E */
   { LTRS, 13, 13, 13},  /*70 F */
   { LTRS, 26, 26, 26},  /*70 G */
   { LTRS, 20, 20, 20},  /*72 H */
   { LTRS, 6 ,  6,  6},  /*73 I */
   { LTRS, 11, 11, 11},  /*74 J */
   { LTRS, 15, 15, 15},  /*75 K */
   { LTRS, 18, 18, 18},  /*76 L */
   { LTRS, 28, 28, 28},  /*77 M */
   { LTRS, 12, 12, 12},  /*78 N */
   { LTRS, 24, 24, 24},  /*79 O */
   { LTRS, 22, 22, 22},  /*80 P */
   { LTRS, 23, 23, 23},  /*81 Q */
   { LTRS, 10, 10, 10},  /*82 R */
   { LTRS, 5 ,  5,  5},  /*83 S */
   { LTRS, 16, 16, 16},  /*84 T */
   { LTRS, 7 ,  7,  7},  /*85 U */
   { LTRS, 30, 30, 30},  /*86 V */
   { LTRS, 19, 19, 19},  /*87 W */
   { LTRS, 29, 29, 29},  /*88 X */
   { LTRS, 21, 21, 21},  /*89 Y */
   { LTRS, 17, 17, 17},  /*90 Z */
   { FIGS, 15, 15, 15},  /*91 [ (L bkt)      substituted())*/
   { FIGS, 29, 29, 29},  /*92 \ (back slash) substituted (/)*/
   { FIGS, 18, 18, 18},  /*93 ] (R bkt)      substituted()) */
   { BOTH, UU, UU, UU},  /*94 ^ (caret) */
   { FIGS,  3,  3,  3}   /*95 _ (underscore)  substituted(-) */
};

char state= 0;     /* assume initial LTRS state */
char last_state= NEITHER;   /* unspecified state */

 char * morsecode[] = {
  /* */  "3     ",  /* first offset = 32 space */
  /* */  "3     ",
  /* */  "3     ",
  /* */  "3     ",
  /* */  "3     ",
  /* */  "3     ",
  /* */  "3     ",
  /*'*/  "3     ",  
  /*(*/  "212212",
  /*)*/  "212212",
  /*ack*/"3     ",
  /*+*/  "3     ",
  /*,*/  "221122",
  /*-*/  "22122 ",
  /*.*/  "121212",
  /*/*/  "21121 ",
  /*0*/  "22222 ",
  /*1*/  "12222 ",
  /*2*/  "11222 ",
  /*3*/  "11122 ",
  /*4*/  "11112 ",
  /*5*/  "11111 ",
  /*6*/  "21111 ",
  /*7*/  "22111 ",
  /*8*/  "22211 ",
  /*9*/  "22221 ",
  /*:*/  "111222",
  /*;*/  "212121",
  /*<*/  "3     ",
  /*=*/  "3     ",
  /*>*/  "3     ",
  /*?*/  "112211",
  /*@*/  "3     ",
  /*A*/  "12    ",
  /*B*/  "2111  ",
  /*C*/  "2121  ",
  /*D*/  "211   ",
  /*E*/  "1     ",
  /*F*/  "1121  ",
  /*G*/  "221   ",
  /*H*/  "1111  ",
  /*I*/  "11    ",
  /*J*/  "1222  ",
  /*K*/  "212   ",
  /*L*/  "1211  ",
  /*M*/  "22    ",
  /*N*/  "21    ",
  /*O*/  "222   ",
  /*P*/  "1221  ",
  /*Q*/  "2212  ",
  /*R*/  "121   ",
  /*S*/  "111   ",
  /*T*/  "2     ",
  /*U*/  "112   ",
  /*V*/  "1112  ",
  /*W*/  "122   ",
  /*X*/  "2112  ",
  /*Y*/  "2122  ",
  /*Z*/  "2211  ",
  /* */  "3     ",
  /* */  "3     ",
  /* */  "3     ",
  /* */  "3     ",
  /* */  "3     ",
  /* */  "3     ",
  /* */  "3     ",
  /* */  "3     ",
  /* */  "3     ",
  /* */  "3     ",
  /* */  "3     ",
  /* */  "3     "
    };

/************************************
           ITA2    Telex Mil.           
No. Letter Figure  Fig.  Fig.   ITA2   
--- ------ ------  ----- -----  -----   
 1   A      -      -     -      YYBBB   
 2   B      ?      ?     ?      YBBYY  
 3   C      :      :     :      BYYYB    
 4   D      $(1)   wru   $      YBBYB   
 5   E      3      3     3      YBBBB  
 6   F      %(2)   $     !      YBYYB  
 7   G      &(2)   &     &      BYBYY  
 8   H      #(2)   #     stop   BBYBY  
 9   I      8      8     8      BYYBB  
10   J      @(3)   bell  '      YYBYB  
11   K      (      (     (      YYYYB  
12   L      )      )     )      BYBBY  
13   M      .      .     .      BBYYY  
14   N      ,      ,     ,      BBYYB  
15   O      9      9     9      BBBYY  
16   P      0      0     0      BYYBY  
17   Q      1      1     1      YYYBY  
18   R      4      4     4      BYBYB  
19   S      '(3)   '     bell   YBYBB  
20   T      5      5     5      BBBBY   
21   U      7      7     7      YYYBB   
22   V      =      ;     ;      BYYYY  
23   W      2      2     2      YYBBY   
24   X      /      /     /      YBYYY  
25   Y      6      6     6      YBYBY  
26   Z      +(4)   "     "      YBBBY   
27  cr      cr     cr    cr     BBBYB  
28  lf      lf     lf    lf     BYBBB  
29  ls      ls     ls    ls     YYYYY  
30  fs      fs     fs    fs     YYBYY   
31  sp      sp     sp    sp     BBYBB   
*************************************/
/* finis */

